commit aef7d09baf91341540e7d468419918d58dd33601
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Tue Nov 30 10:17:09 2021

    Fix -freorder-blocks-and-partition glitch with Windows SEH (continued)
    
    This fixes a thinko in the fix for the -freorder-blocks-and-partition
    glitch with SEH on 64-bit Windows:
      https://gcc.gnu.org/pipermail/gcc-patches/2021-February/565208.html
    
    Even if no exceptions are active, e.g. in C, we need to consider calls.
    
    gcc/
            PR target/103274
            * config/i386/i386.c (ix86_output_call_insn): Beef up comment about
            nops emitted with SEH.
            * config/i386/winnt.c (i386_pe_seh_unwind_emit): When switching to
            the cold section, emit a nop before the directive if the previous
            active instruction is a call.

diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index 1448f3609c3..8e8c8beb366 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -16149,8 +16149,10 @@ ix86_output_call_insn (rtx_insn *insn, rtx call_op)
 	    break;
 
 	  /* If we get to the epilogue note, prevent a catch region from
-	     being adjacent to the standard epilogue sequence.  If non-
-	     call-exceptions, we'll have done this during epilogue emission. */
+	     being adjacent to the standard epilogue sequence.  Note that,
+	     if non-call exceptions are enabled, we already did it during
+	     epilogue expansion, or else, if the insn can throw internally,
+	     we already did it during the reorg pass.  */
 	  if (NOTE_P (i) && NOTE_KIND (i) == NOTE_INSN_EPILOGUE_BEG
 	      && !flag_non_call_exceptions
 	      && !can_throw_internal (insn))
diff --git a/gcc/config/i386/winnt.c b/gcc/config/i386/winnt.c
index b66263ad243..2d1debf2dbd 100644
--- a/gcc/config/i386/winnt.c
+++ b/gcc/config/i386/winnt.c
@@ -1244,9 +1244,9 @@ i386_pe_seh_unwind_emit (FILE *asm_out_file, rtx_insn *insn)
   seh = cfun->machine->seh;
   if (NOTE_P (insn) && NOTE_KIND (insn) == NOTE_INSN_SWITCH_TEXT_SECTIONS)
     {
-      /* See ix86_seh_fixup_eh_fallthru for the rationale.  */
+      /* See ix86_output_call_insn/seh_fixup_eh_fallthru for the rationale.  */
       rtx_insn *prev = prev_active_insn (insn);
-      if (prev && !insn_nothrow_p (prev))
+      if (prev && (CALL_P (prev) || !insn_nothrow_p (prev)))
 	fputs ("\tnop\n", asm_out_file);
       fputs ("\t.seh_endproc\n", asm_out_file);
       seh->in_cold_section = true;

